' ------------------------------------------------------------------------------------
' irr::core::plane3di wrappers (done)
' ------------------------------------------------------------------------------------

Public 

Type Plane3di Extends IrrBase Final

	Method EqEq:Int(pOther:Plane3di)
		Return IrrCore_Plane3di_EqEq(handle,pOther.handle)
	EndMethod

	Method NotEq:Int(pOther:Plane3di)
		Return IrrCore_Plane3di_NotEq(handle,pOther.handle)
	EndMethod
	
	Method getMemberPoint:Vector3di()
		' set to not delete
		Return Vector3di.createFromHandle(IrrCore_Plane3di_getMemberPoint(handle),False)
	EndMethod
	
	Method getDistanceTo:Int(pPoint:Vector3di)	
		Return IrrCore_Plane3di_getDistanceTo(handle,pPoint.handle)
	EndMethod
	
	Method getD:Int()
		Return IrrCore_Plane3di_getD(handle)
	EndMethod
	
	Method getNormal:Vector3di()
		Return Vector3di.createFromHandle(IrrCore_Plane3di_getNormal(handle))
	EndMethod

	Method isFrontFacing:Int(pLookDirection:Vector3di)
		Return IrrCore_Plane3di_isFrontFacing(handle,pLookDirection.handle)
	EndMethod
	
	Method classifyPointRelation:Int(pPoint:Vector3di)
		Return IrrCore_Plane3di_classifyPointRelation(handle,pPoint.handle)
	EndMethod
	
	Method recalculateD(pMPoint:Vector3di) 
		IrrCore_Plane3di_recalculateD(handle,pMPoint.handle)
	EndMethod

	Method getIntersectionWithLine:Int(pLinePoint:Vector3di,pLineVect:Vector3di,pOutIntersection:Vector3di)
		Return IrrCore_Plane3di_getIntersectionWithLine(handle,pLinePoint.handle,pLineVect.handle,pOutIntersection.handle)
	EndMethod
	
	Method existsInterSection:Int(pOther:Plane3di)
		Return IrrCore_Plane3di_existsInterSection(handle,pOther.handle)
	EndMethod
	
	Method getIntersectionWithPlane:Int(pOther:Plane3di,pOutLinePoint:Vector3di,pOutLineVect:Vector3di)	
		Return IrrCore_Plane3di_getIntersectionWithPlane(handle,pOther.handle,pOutLinePoint.handle,pOutLineVect.handle)
	EndMethod
	
	Method getIntersectionWithPlanes:Int(pO1:Plane3di,pO2:Plane3di,pOutPoint:Vector3di)
		Return IrrCore_Plane3di_getIntersectionWithPlanes(handle,pO1.handle,pO2.handle,pOutPoint.handle)
	EndMethod
	
	Method getIntersectionWithLimitedLine:Int(pLinePoint1:Vector3di,pLinePoint2:Vector3di,pOutIntersection:Vector3di)
		Return IrrCore_Plane3di_getIntersectionWithLimitedLine(handle,pLinePoint1.handle,pLinePoint2.handle,pOutIntersection.handle)
	EndMethod

	'--------------------------------------------
	' set routines
	'--------------------------------------------

	Method setPlaneFromPoints(pPoint1:Vector3di,pPoint2:Vector3di,pPoint3:Vector3di)
		IrrCore_Plane3di_setPlaneFromPoints(handle,pPoint1.handle,pPoint2.handle,pPoint3.handle)
	EndMethod

	Method setPlaneFromPointVect(pPoint:Vector3di,pVect:Vector3di)
		IrrCore_Plane3di_setPlaneFromPointVect(handle,pPoint.handle,pVect.handle)
	EndMethod
	
	Method setPlaneFromVectVal(pVect:Vector3di,d:Int)
		IrrCore_Plane3di_setPlaneFromVectVal(handle,pVect.handle,d)
	EndMethod

	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------

	Function create:Plane3di()
		Return createFromHandle(IrrCore_Plane3di_new())
	EndFunction
	
	Function createNewFromVals:Plane3di(px:Int,py:Int,pz:Int,nx:Int,ny:Int,nz:Int)
		Return createFromHandle(IrrCore_Plane3di_newFromVals(px,py,pz,nx,ny,nz))
	EndFunction
	
	Function createNewFromPoints:Plane3di(pPoint1:Vector3di,pPoint2:Vector3di,pPoint3:Vector3di)
		Return createFromHandle(IrrCore_Plane3di_newFromPoints(pPoint1.handle,pPoint2.handle,pPoint3.handle))
	EndFunction
	
	Function createNewFromPlane:Plane3di(pPlane:Plane3di)
		Return createFromHandle(IrrCore_Plane3di_newFromPlane(pPlane.handle))
	EndFunction
	
	Function createNewFromPointNormal:Plane3di(pPoint:Vector3di,pNormal:Vector3di)
		Return createFromHandle(IrrCore_Plane3di_newFromPointNormal(pPoint.handle,pNormal.handle))
	EndFunction
	
	Function createFromHandle:Plane3di(pPlane:Int,bMustDel:Int=True)
		If Not pPlane Then Return Null
		Local oRetVal:Plane3di=New Plane3di
		oRetVal.attach(pPlane,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrCore_Plane3di_del(handle)
	EndMethod	
	
EndType