
Public

Type Vector2df Extends IrrBase Final

	Method normalize:Vector2df()
		Return createFromHandle(IrrCore_Vector2df_normalize(handle),False)
	EndMethod
	
	Method getAngle:Double()
		Return IrrCore_Vector2df_getAngle(handle)
	EndMethod

	Method getAngleWith:Double(pOther:Vector2df)
		Return IrrCore_Vector2df_getAngleWith(handle,pOther.handle)
	EndMethod

	Method rotateBy(degrees:Double,pCenter:Vector2df)
		IrrCore_Vector2df_rotateBy(handle,degrees,pCenter.handle)
	EndMethod

	Method getDistanceFrom:Double(pOther:Vector2df)
		Return IrrCore_Vector2df_getDistanceFrom(handle,pOther.handle)
	EndMethod

	Method dotProduct:Float(pOther:Vector2df)
		Return IrrCore_Vector2df_dotProduct(handle,pOther.handle)
	EndMethod

	Method getLength:Double()
		Return IrrCore_Vector2df_getLength(handle)
	EndMethod
	
	Method interpolate(a:Vector2df,b:Vector2df,t:Float)	
		IrrCore_Vector2df_interpolate(handle,a.handle,b.handle,t)
	EndMethod

	Method equals:Int(other:Vector2df)
		Return IrrCore_Vector2df_equals(handle,other.handle)
	EndMethod
	
	Method getLengthSQ:Float()
		Return IrrCore_Vector2df_getLengthSQ(handle)
	EndMethod
	
	Method getDistanceFromSQ:Float(other:Vector2df)
		Return IrrCore_Vector2df_getDistanceFromSQ(handle,other.handle)
	EndMethod
	
	Method isBetweenPoints:Int(pbegin:Vector2df,pend:Vector2df)
		Return IrrCore_Vector2df_isBetweenPoints(handle,pbegin.handle,pend.handle)
	EndMethod
	
	Method getInterpolated_quadratic:Vector2df(v2:Vector2df,v3:Vector2df,d:Float)
		Return Vector2df.createFromHandle(IrrCore_Vector2df_getInterpolated_quadratic(handle,v2.handle,v3.handle,d),True)
	EndMethod
	
	'--------------------------------------------
	' operator overloads
	'--------------------------------------------
	
	Method setEq:Vector2df(pOther:Vector2df)
		IrrCore_Vector2df_setEq(handle,pOther.handle)
		Return Self
	EndMethod

	Method EqEq:Int(pOther:Vector2df)
		Return IrrCore_Vector2df_EqEq(handle,pOther.handle)
	EndMethod

	Method NotEq:Int(pOther:Vector2df)
		Return IrrCore_Vector2df_NotEq(handle,pOther.handle)
	EndMethod
	
	Method Plus:Vector2df(pOther:Vector2df)		
		Return createFromHandle(IrrCore_Vector2df_Plus(handle,pOther.handle))
	EndMethod
	
	Method PlusEq:Vector2df(pOther:Vector2df)
		IrrCore_Vector2df_PlusEq(handle,pOther.handle)
		Return Self
	EndMethod
	
	Method Minus:Vector2df(pOther:Vector2df)		
		Return createFromHandle(IrrCore_Vector2df_Minus(handle,pOther.handle))
	EndMethod
	
	Method MinusEq:Vector2df(pOther:Vector2df)		
		IrrCore_Vector2df_MinusEq(handle,pOther.handle)
		Return Self
	EndMethod
	
	Method MultVect:Vector2df(pOther:Vector2df)
		Return createFromHandle(IrrCore_Vector2df_MultVect(handle,pOther.handle))
	EndMethod
	
	Method Mult:Vector2df(v:Float)
		Return createFromHandle(IrrCore_Vector2df_Mult(handle,v))
	EndMethod

	Method MultEqVect:Vector2df(pOther:Vector2df)
		IrrCore_Vector2df_MultEqVect(handle,pOther.handle)
		Return Self
	EndMethod
	
	Method MultEq:Vector2df(v:Float)
		IrrCore_Vector2df_MultEq(handle,v)
		Return Self
	EndMethod
	
	Method DivVect:Vector2df(pOther:Vector2df)
		Return createFromHandle(IrrCore_Vector2df_DivVect(handle,pOther.handle))
	EndMethod

	Method Div:Vector2df(v:Float)
		Return createFromHandle(IrrCore_Vector2df_Div(handle,v))
	EndMethod

	Method DivEqVect:Vector2df(pOther:Vector2df)
		IrrCore_Vector2df_DivEqVect(handle,pOther.handle)
		Return Self
	EndMethod
	
	Method DivEq:Vector2df(v:Float)
		IrrCore_Vector2df_DivEq(handle,v)
		Return Self
	EndMethod

	Method LessEq:Int(other:Vector2df)
		Return IrrCore_Vector2df_LessEq(handle,other.handle)
	EndMethod
	
	Method GreatEq:Int(other:Vector2df)
		Return IrrCore_Vector2df_GreatEq(handle,other.handle)
	EndMethod
	
	Method Less:Int(other:Vector2df)
		Return IrrCore_Vector2df_Less(handle,other.handle)
	EndMethod
	
	Method Great:Int(other:Vector2df)
		Return IrrCore_Vector2df_Great(handle,other.handle)
	EndMethod
	
	'--------------------------------------------
	' set routines
	'--------------------------------------------

	Method setX(x:Float)
		IrrCore_Vector2df_setX(handle,x)
	EndMethod
	
	Method setY(y:Float)
		IrrCore_Vector2df_setY(handle,y)
	EndMethod
	
	Method setFromVect(pOther:Vector2df)
		IrrCore_Vector2df_setFromVect(handle,pOther.handle)
	EndMethod

	Method set(x:Float,y:Float)
		IrrCore_Vector2df_set(handle,x,y)
	EndMethod

	'--------------------------------------------
	' get routines
	'--------------------------------------------

	Method getX:Float()
		Return IrrCore_Vector2df_getX(handle)
	EndMethod
	Method getY:Float()
		Return IrrCore_Vector2df_getY(handle)
	EndMethod

	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------

	Function create:Vector2df()
		Return createFromHandle(IrrCore_Vector2df_new())
	EndFunction

	Function createFromVals:Vector2df(x:Float,y:Float)
		Return createFromHandle(IrrCore_Vector2df_new(x,y))
	EndFunction

	Function createFromVect:Vector2df(vect:Vector2df)
		Return createFromHandle(IrrCore_Vector2df_newFromVect(vect.handle))
	EndFunction

	Function createFromHandle:Vector2df(pVect:Int,bMustDel:Int=True)
		If Not pVect Then Return Null
		Local oRetVal:Vector2df=New Vector2df
		oRetVal.attach(pVect,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrCore_Vector2df_del(handle)
	EndMethod
EndType

