' ------------------------------------------------------------------------------------
'  irr::gui::IGUIButton wrappers
'  do Not Delete a pointer To this
' ------------------------------------------------------------------------------------
Public

'enum EGUI_BUTTON_STATE

Const EGBS_BUTTON_UP:Int = 0
Const EGBS_BUTTON_DOWN:Int = 1
Const EGBS_BUTTON_MOUSE_OVER:Int = 2
Const EGBS_BUTTON_MOUSE_OFF:Int = 3
Const EGBS_BUTTON_FOCUSED:Int = 4
Const EGBS_BUTTON_NOT_FOCUSED:Int = 5
Const EGBS_COUNT:Int = 6

Global GUIButtonStateNames:String[] = ..
[ ..
	"buttonUp", ..
	"buttonDown", ..
	"buttonMouseOver", ..
	"buttonMouseOff", ..
	"buttonFocused", ..
	"buttonNotFocused", ..
	"" ..
]

Type IGUIButton Extends IGUIElement Final

	Function createFromHandle:IGUIButton(pHandle:Int,bMustDel:Int=False,pGenFunc:Byte Ptr=Null)
		If Not pHandle Then Return Null
		Local oRetVal:IGUIButton=New IGUIButton
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
		
	Method isPressed:Int()
		Return IrrGUI_IGUIButton_isPressed(handle)
	EndMethod
	
	Method setPressed(bPressed:Int)
		IrrGUI_IGUIButton_setPressed(handle,bPressed)
	EndMethod
	
	Method setIsPushButton(bIsPushButton:Int)
		IrrGUI_IGUIButton_setIsPushButton(handle,bIsPushButton)
	EndMethod
	
	Method setOverrideFont(font:IGUIFont)
		IrrGUI_IGUIButton_setOverrideFont(handle,font.handle)
	EndMethod
	
	Method setImage(texture:ITexture)
		IrrGUI_IGUIButton_setImage(handle,texture.handle)
	EndMethod
	
	Method setImageFromSegment(texture:ITexture,pos:Recti)
		IrrGUI_IGUIButton_setImageFromSegment(handle,texture.handle,pos.handle)
	EndMethod
	
	Method setPressedImage(texture:ITexture)
		IrrGUI_IGUIButton_setPressedImage(handle,texture.handle)
	EndMethod 
	
	Method setPressedImageFromSegment(texture:ITexture,pos:Recti)
		IrrGUI_IGUIButton_setPressedImageFromSegment(handle,texture.handle,pos.handle)
	EndMethod

	Method setUseAlphaChannel(bUseAlphaChannel:Int)
		IrrGUI_IGUIButton_setUseAlphaChannel(handle,bUseAlphaChannel)
	EndMethod

	Method getUseAlphaChannel:Int()
		Return IrrGUI_IGUIButton_getUseAlphaChannel(handle)
	EndMethod

	Method setSpriteBank(bank:IGUISpriteBank)
		IrrGUI_IGUIButton_setSpriteBank(handle,bank.handle)
	EndMethod
	
	Method setSprite(EGUI_BUTTON_STATE:Int,index:Int,color:SColor=Null,bLoop:Int=False)
		If Not color Or Not color.IsValid() Then color=_SCOLOR(255,255,255,255)
		IrrGUI_IGUIButton_setSprite(handle,EGUI_BUTTON_STATE,index,color.handle,bLoop)
	EndMethod
	
	Method setDrawBorder(bBorder:Int)
		IrrGUI_IGUIButton_setDrawBorder(handle,bBorder)
	EndMethod

EndType

