Public

'! Customizable symbols for GUI
'enum EGUI_DEFAULT_ICON
Const EGDI_WINDOW_MAXIMIZE:Int = 0
Const EGDI_WINDOW_RESTORE:Int = 1
Const EGDI_WINDOW_CLOSE:Int = 2
Const EGDI_WINDOW_MINIMIZE:Int = 3
Const EGDI_CURSOR_UP:Int = 4
Const EGDI_CURSOR_DOWN:Int = 5
Const EGDI_CURSOR_LEFT:Int = 6
Const EGDI_CURSOR_RIGHT:Int = 7
Const EGDI_MENU_MORE:Int = 8
Const EGDI_CHECK_BOX_CHECKED:Int = 9
Const EGDI_DROP_DOWN:Int = 10
Const EGDI_SMALL_CURSOR_UP:Int = 11
Const EGDI_SMALL_CURSOR_DOWN:Int = 12
Const EGDI_RADIO_BUTTON_CHECKED:Int = 13 
Const EGDI_FILE:Int = 14
Const EGDI_DIRECTORY:Int = 15
Const EGDI_COUNT:Int = 16

Global GUISkinIconNames:String[] = ..
[ ..
	"windowMaximize", ..
	"windowRestore", ..
	"windowClose", ..
	"windowMinimize", ..
	"cursorUp", ..
	"cursorDown", ..
	"cursorLeft", ..
	"cursorRight", ..
	"menuMore", ..
	"checkBoxChecked", ..
	"dropDown", ..
	"smallCursorUp", ..
	"smallCursorDown", ..
	"radioButtonChecked", ..
	"file", ..
	"directory", ..
	"" ..
]

' ------------------------------------------------------------------------------------
'  irr::gui::IGUISkin wrappers
'  do Not Delete a pointer To this
' ------------------------------------------------------------------------------------
Type IGUISkin Extends IAttributeExchangingObject Final

	Function createFromHandle:IGUISkin(pHandle:Int,bMustDel:Int=False,pGenFunc:Byte Ptr=Null)
		If Not pHandle Then Return Null
		Local oRetVal:IGUISkin=New IGUISkin
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction	
	
	Method getSize:Int(EGUI_DEFAULT_SIZE_which:Int)
		Return IrrGUI_IGUISkin_getSize(handle,EGUI_DEFAULT_SIZE_which)
	EndMethod
	
	Method setSize(EGUI_DEFAULT_SIZE_which:Int,size:Int)
		IrrGUI_IGUISkin_setSize(handle,EGUI_DEFAULT_SIZE_which,size)
	EndMethod
	
	Method GetColor:SColor(EGUI_DEFAULT_COLOR_which:Int)
		Return SColor.createFromHandle(IrrGUI_IGUISkin_getColor(handle,EGUI_DEFAULT_COLOR_which))
	EndMethod

	Method SetColor(EGUI_DEFAULT_COLOR_which:Int,newColor:SColor)
		IrrGUI_IGUISkin_setColor(handle,EGUI_DEFAULT_COLOR_which,newColor.handle)
	EndMethod
	
	Method getFont:IGUIFont()
		'  do Not Delete this pointer
		Return IGUIFont.createFromHandle(IrrGUI_IGUISkin_getFont(handle),False)
	EndMethod
	
	Method setFont(font:IGUIFont)
		IrrGUI_IGUISkin_setFont(handle,font.handle)
	EndMethod
	
	Method getDefaultText:String(EGUI_DEFAULT_TEXT_which:Int)
		Return IrrGUI_IGUISkin_getDefaultText(handle,EGUI_DEFAULT_TEXT_which)
	EndMethod
	
	Method setDefaultText(EGUI_DEFAULT_TEXT_which:Int,newText:String)
		IrrGUI_IGUISkin_setDefaultText(handle,EGUI_DEFAULT_TEXT_which,newText)
	EndMethod

	Method draw3DButtonPaneStandard(element:IGUIElement,rect:Recti,clip:Recti=Null)
		If clip=Null Then clip=New Recti ' create a null value
		IrrGUI_IGUISkin_draw3DButtonPaneStandard(handle,element.handle,rect.handle,clip.handle)
	EndMethod
	
	Method draw3DButtonPanePressed(element:IGUIElement,rect:Recti,clip:Recti=Null)
		If clip=Null Then clip=New Recti ' create a null value
		IrrGUI_IGUISkin_draw3DButtonPanePressed(handle,element.handle,rect.handle,clip.handle)
	EndMethod
	
	Method draw3DSunkenPane(element:IGUIElement,bgcolor:SColor,bFlat:Int, bFillBackGround:Int,rect:Recti,clip:Recti=Null)
		If clip=Null Then clip=New Recti ' create a null value
		IrrGUI_IGUISkin_draw3DSunkenPane(handle,element.handle,bgcolor.handle,bFlat,bFillBackGround,rect.handle,clip.handle)
	EndMethod
	
	' must Delete Return value
	Method draw3DWindowBackground:Recti(element:IGUIElement,bDrawTitleBar:Int,titleBarColor:SColor,rect:Recti,clip:Recti=Null)
		If clip=Null Then clip=New Recti ' create a null value
		Return Recti.createFromHandle(IrrGUI_IGUISkin_draw3DWindowBackground(handle,element.handle,bDrawTitleBar,titleBarColor.handle,rect.handle,clip.handle),True)
	EndMethod
	
	Method draw3DMenuPane(element:IGUIElement,rect:Recti,clip:Recti=Null)
		If clip=Null Then clip=New Recti ' create a null value
		IrrGUI_IGUISkin_draw3DMenuPane(handle,element.handle,rect.handle,clip.handle)
	EndMethod
	
	Method draw3DToolBar(element:IGUIElement,rect:Recti,clip:Recti=Null)
		If clip=Null Then clip=New Recti ' create a null value
		IrrGUI_IGUISkin_draw3DToolBar(handle,element.handle,rect.handle,clip.handle)
	EndMethod
	
	Method draw3DTabButton(element:IGUIElement,bActive:Int,rect:Recti, clip:Recti=Null)
		If clip=Null Then clip=New Recti ' create a null value
		IrrGUI_IGUISkin_draw3DTabButton(handle,element.handle,bActive,rect.handle,clip.handle)
	EndMethod

	Method draw3DTabBody(element:IGUIElement,bBorder:Int,bBackground:Int,rect:Recti, clip:Recti=Null)
		If clip=Null Then clip=New Recti ' create a null value
		IrrGUI_IGUISkin_draw3DTabBody(handle,element.handle,bBorder,bBackground,rect.handle,clip.handle)
	EndMethod

	Method getSpriteBank:IGUISpriteBank()
		Return IGUISpriteBank.createFromHandle(IrrGUI_IGUISkin_getSpriteBank(handle),False)
	EndMethod
	
	Method setSpriteBank(bank:IGUISpriteBank)
		IrrGUI_IGUISkin_setSpriteBank(handle,bank.handle)
	EndMEthod
	
	Method getIcon:Int(EGUI_DEFAULT_ICON:Int)
		Return IrrGUI_IGUISkin_getIcon(handle,EGUI_DEFAULT_ICON)
	EndMethod
	
	Method setIcon(EGUI_DEFAULT_ICON:Int,index:Int)
		IrrGUI_IGUISkin_setIcon(handle,EGUI_DEFAULT_ICON,index)
	EndMethod
	
	Method getType:Int()
		Return IrrGUI_IGUISkin_getType(handle)
	EndMethod
	
	Method drawIcon(element:IGUIElement,EGUI_DEFAULT_ICON:Int,pos:Position2di,starttime:Int=0,currenttime:Int=0,bLoop:Int=False,clip:Recti=Null)
		If Not clip Or Not clip.IsValid() Then clip=new Recti
		IrrGUI_IGUISkin_drawIcon(handle,element.handle,EGUI_DEFAULT_ICON,pos.handle,starttime,currenttime,bLoop,clip.handle)
	EndMethod

EndType


