' ------------------------------------------------------------------------------------
' irr::io::IFileList wrappers
' be sure to call the drop function when done 
' ------------------------------------------------------------------------------------
Public

Type IFileList Extends Tirr_IUnknown Final

	Function createFromHandle:IFileList(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:IFileList=New IFileList
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method getFileCount:Int()	
		Return IrrIO_IFileList_getFileCount(handle)
	EndMethod
	
	Method getFileName:String(idx:Int)
		Return String.FromCString(IrrIO_IFileList_getFileName(handle,idx))
	EndMethod
	
	Method getFullFileName:String(idx:Int)
		Return String.FromCString(IrrIO_IFileList_getFullFileName(handle,idx))
	EndMethod
	
	Method isDirectory:Int(idx:Int)
		Return IrrIO_IFileList_isDirectory(handle,idx)
	EndMethod

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrIO_IFileList_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrIO_IFileList_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrIO_IFileList_grab(handle)
	EndMethod
	
	Method Delete()
		If (mustdelete) Then drop()
	EndMethod

EndType


