' ------------------------------------------------------------------------------------
' irr::io::IReadFile wrappers
' be sure To call the drop Function when done
' ------------------------------------------------------------------------------------
' 2005/11/28 - implemented fix for read() from Doug Stastny (Budman)
'

Public

Type IReadFile Extends Tirr_IUnknown Final

	Function createFromHandle:IReadFile(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:IReadFile=New IReadFile
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method getFileName:String()
		Return String.FromCString(IrrIO_IReadFile_getFileName(handle))
	EndMethod
	
	Method getPos:Int()
		Return IrrIO_IReadFile_getPos(handle)
	EndMethod
	
	Method getSize:Int()
		Return IrrIO_IReadFile_getSize(handle)
	EndMethod
	
	Method read:Int(out:Byte Ptr,sizeToRead:Int)
		Return IrrIO_IReadFile_read(handle,out,sizeToRead)
	EndMethod
	
	Method seek:Int(finalPos:Int,bRelativeMovement:Int=False)
		Return IrrIO_IReadFile_seek(handle,finalPos,bRelativeMovement)
	EndMethod

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrIO_IReadFile_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrIO_IReadFile_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrIO_IReadFile_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod
EndType



