' ------------------------------------------------------------------------------------
' irr::io::IXMLWriter wrappers
' be sure To call the drop Function when done
' ------------------------------------------------------------------------------------
Public

Type IXMLWriter Extends Tirr_IUnknown Final

	Function createFromHandle:IXMLWriter(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:IXMLWriter=New IXMLWriter
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method writeClosingTag(name:String)
		IrrIO_IXMLWriter_writeClosingTag(handle,name)
	EndMethod
	Method writeComment(comment:String)
		IrrIO_IXMLWriter_writeComment(handle,comment)
	EndMethod
	
	Method writeElement(name:String,bEmpty:Int=False,attr1Name:String=Null,attr1Value:String=Null,attr2Name:String=Null,attr2Value:String=Null,attr3Name:String=Null,attr3Value:String=Null,attr4Name:String=Null,attr4Value:String=Null,attr5Name:String=Null,attr5Value:String=Null)
		IrrIO_IXMLWriter_writeElement(handle,name,bEmpty,attr1Name,attr1Value,attr2Name,attr2Value,attr3Name,attr3Value,attr4Name,attr4Value,attr5Name,attr5Value)
	EndMethod
	
	Method writeElementFromArray(name:String,bEmpty:Int,names:String[],values:String[])
		
		Local namesCount:Int=names.Dimensions()[0]
		Local valuesCount:Int=values.Dimensions()[0]
		Local namesPtr:Byte Ptr[namesCount]
		Local valuesPtr:Byte Ptr[valuesCount]
		
		' setup the ptr arrays
		For Local i:Int=0 To namesCount
			namesPtr[i]=names[i].ToCString()
		Next
		For Local i:Int=0 To valuesCount
			valuesPtr[i]=values[i].ToCString()
		Next
		
		IrrIO_IXMLWriter_writeElementFromArray(handle,name,bEmpty,namesPtr,namesCount,valuesPtr,valuesCount)
		
		' free the ptr arrays
		For Local i:Int=0 To namesCount
			MemFree(namesPtr[i])
		Next
		For Local i:Int=0 To valuesCount
			MemFree(valuesPtr[i])
		Next
	EndMethod

	Method writeLineBreak()
		IrrIO_IXMLWriter_writeLineBreak(handle)
	EndMethod
	
	Method writeText(text:String)
		IrrIO_IXMLWriter_writeText(handle,text)
	EndMethod
	
	Method writeXMLHeader()
		IrrIO_IXMLWriter_writeXMLHeader(handle)
	EndMethod
 
	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrIO_IXMLWriter_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrIO_IXMLWriter_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrIO_IXMLWriter_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod
EndType



