' ------------------------------------------------------------------------------------
' irr::SEvent wrappers
' ------------------------------------------------------------------------------------
Public

Type SEvent Extends IrrBase Final
	
	Function createFromHandle:SEvent(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:SEvent=New SEvent
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then Irr_SEvent_del(handle)
	EndMethod	

	Function create:SEvent()
		Return SEvent.createFromHandle(Irr_SEvent_new())
	EndFunction

	Method setEventType(EEVENT_TYPE:Int)
		Irr_SEvent_setEventType(handle,EEVENT_TYPE)
	EndMethod
	
	Method getEventType:Int()
		Return Irr_SEvent_getEventType(handle)
	EndMethod
	
	Method setGUIEventCaller(element:IGUIElement)
		Irr_SEvent_setGUIEventCaller(handle,element.handle)
	EndMethod
	
	Method getGUIEventCaller:IGUIElement()
		' do not delete
		Return IGUIElement.createFromHandle(Irr_SEvent_getGUIEventCaller(handle),False)
	EndMethod
	
	Method setGUIEventType(EGUI_EVENT_TYPE:Int)
		Irr_SEvent_setGUIEventType(handle,EGUI_EVENT_TYPE)
	EndMethod 
	
	Method getGUIEventType:Int()
		Return Irr_SEvent_getGUIEventType(handle)
	EndMethod
	
	Method getMouseEventType:Int()
		Return Irr_SEvent_getMouseEventType(handle)
	EndMethod
	
	Method setMouseEventType(EMOUSE_INPUT_EVENT:Int)
		Irr_SEvent_setMouseEventType(handle,EMOUSE_INPUT_EVENT)
	EndMethod
	
	Method getMouseX:Int()
		Return Irr_SEvent_getMouseX(handle)
	EndMethod
	
	Method getMouseY:Int()
		Return Irr_SEvent_getMouseY(handle)
	EndMethod
	
	Method setMouse(x:Int,y:Int)
		Irr_SEvent_setMouse(handle,x,y)
	EndMethod 
	
	Method getMouseWheel:Float()
		Return Irr_SEvent_getMouseWheel(handle)
	EndMethod
	
	Method setMouseWheel(wheel:Float)
		Irr_SEvent_setMouseWheel(handle,wheel)
	EndMethod
	
	Method getKeyInputChar:String()
		Return Irr_SEvent_getKeyInputChar(handle)
	EndMethod
	
	Method setKeyInputChar(char:String)
		Irr_SEvent_setKeyInputChar(handle,char)
	EndMethod
	
	Method getKeyInputKey:Int()
		Return Irr_SEvent_getKeyInputKey(handle)
	EndMethod
	
	Method setKeyInputKey(EKEY_CODE:Int)
		Irr_SEvent_setKeyInputKey(handle,EKEY_CODE)
	EndMethod
	
	Method getKeyPressedDown:Int()
		Return Irr_SEvent_getKeyPressedDown(handle)
	EndMethod
	
	Method setKeyPressedDown(bPressed:Int)
		Irr_SEvent_setKeyPressedDown(handle,bPressed)
	EndMethod
	
	Method getKeyShift:Int()
		Return Irr_SEvent_getKeyShift(handle)
	EndMethod
	
	Method setKeyShift(bPressed:Int)
		Irr_SEvent_setKeyShift(handle,bPressed)
	EndMethod
	
	Method getKeyControl:Int()
		Return Irr_SEvent_getKeyControl(handle)
	EndMethod
	
	Method setKeyControl(bPressed:Int)
		Irr_SEvent_setKeyControl(handle,bPressed)
	EndMethod
	
	Method getLogText:String()
		Return String.FromCString(Irr_SEvent_getLogText(handle))
	EndMethod
	
	Method setLogText(text:String)
		Irr_SEvent_setLogText(handle,text)
	EndMethod
	
	Method getLogLevel:Int()
		Return Irr_SEvent_getLogLevel(handle)
	EndMethod
	
	Method setLogLevel(ELOG_LEVEL:Int)
		Irr_SEvent_setLogLevel(handle,ELOG_LEVEL)
	EndMethod
	
	Method getUserData1:Int()
		Return Irr_SEvent_getUserData1(handle)
	EndMethod
	
	Method setUserData1(data:Int)
		Irr_SEvent_setUserData1(handle,data)
	EndMethod
	
	Method getUserData2:Int()
		Return Irr_SEvent_getUserData2(handle)
	EndMethod
	
	Method setUserData2(data:Int)
		Irr_SEvent_setUserData2(handle,data)
	EndMethod

	Method getUserData3:Float()
		Return Irr_SEvent_getUserData3(handle)
	EndMethod
	
	Method setUserData3(data:Float)
		Irr_SEvent_setUserData3(handle,data)
	EndMethod

EndType





