' ------------------------------------------------------------------------------------
'  irr::scene::IAnimatedMesh wrappers
' ------------------------------------------------------------------------------------
Public

Type IAnimatedMesh Extends Tirr_IUnknown

	Function createFromHandle:IAnimatedMesh(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:IAnimatedMesh=New IAnimatedMesh
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal.cast()
	EndFunction
		
	Method getBoundingBox:AABbox3df()
		Return AABbox3df.createFromHandle(IrrScene_IAnimatedMesh_getBoundingBox(handle))
	EndMethod
	
	Method getFrameCount:Int()
		Return IrrScene_IAnimatedMesh_getFrameCount(handle)
	EndMethod
	
	Method getMesh:IMesh(frame:Int,detailLevel:Int=255,startFrameLoop:Int=-1,endFrameLoop:Int=-1)
		' do not delete
		Return IMesh.createFromHandle(IrrScene_IAnimatedMesh_getMesh(handle,frame,detailLevel,startFrameLoop,endFrameLoop),False)
	EndMethod
	
	Method getMeshType:Int() ' returns E_ANIMATED_MESH_TYPE
		Return IrrScene_IAnimatedMesh_getMeshType(handle) 
	EndMethod

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrScene_IAnimatedMesh_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrScene_IAnimatedMesh_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrScene_IAnimatedMesh_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod

	Method cast:IAnimatedMesh(bTakeOwnership:Int=True)
		Local am_cast:IAnimatedMesh=Null
		Local am_type:Int=getMeshType()
		Local bMustDelete:Int=False

		If bTakeOwnership Then 
			bMustDelete=Self.mustdelete
			Self.mustdelete=False
		EndIf
				
		Select am_type

			Rem
			Case EAMT_OBJ
			Case EAMT_BSP			
			Case EAMT_3DS
			Case EAMT_MY3D
			Case EAMT_LMTS			
			Case EAMT_CSM
			Case EAMT_OCT
			EndRem
			
			Case EAMT_MD2
				am_cast=IAnimatedMeshMD2.createFromHandle(Self.handle,bMustDelete)			
			Case EAMT_MD3
				am_cast=IAnimatedMeshMD3.createFromHandle(Self.handle,bMustDelete)						
			Case EAMT_MS3D
				am_cast=IAnimatedMeshMS3D.createFromHandle(Self.handle,bMustDelete)			
			Case EAMT_X
				am_cast=IAnimatedMeshX.createFromHandle(Self.handle,bMustDelete)			
			Case EAMT_B3D
				am_cast=IAnimatedMeshB3D.createFromHandle(Self.handle,bMustDelete)			
			Default
				am_cast=Self
				Self.mustdelete=bMustDelete
		EndSelect

		Return am_cast
	EndMethod

EndType


