' ------------------------------------------------------------------------------------
'  irr::scene::IAnimatedMeshSceneNode wrappers
' ------------------------------------------------------------------------------------
Public

Type IAnimatedMeshSceneNode Extends ISceneNodeDefault Final

	Function createFromHandle:IAnimatedMeshSceneNode(pHandle:Int,bMustDel:Int=False,pGenFunc:Byte Ptr=Null)
		If Not pHandle Then Return Null
		Local oRetVal:IAnimatedMeshSceneNode=New IAnimatedMeshSceneNode
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method addShadowVolumeSceneNode:IShadowVolumeSceneNode(id:Int=-1,bzfailmethod:Int=True,infinity:Float=10000.0)
		'  do Not Delete
		Return IShadowVolumeSceneNode.createFromHandle(IrrScene_IAnimatedMeshSceneNode_addShadowVolumeSceneNode:Int(handle,id:Int=-1,bzfailmethod:Int=True,infinity),False)
	EndMethod
	
	Method getFrameNr:Int()
		Return IrrScene_IAnimatedMeshSceneNode_getFrameNr:Int(handle)
	EndMethod
	
	Method getMS3DJointNode:ISceneNode(jointName:String)
		'  do Not Delete
		Return ISceneNode.createFromHandle(IrrScene_IAnimatedMeshSceneNode_getMS3DJointNode(handle,jointName),False)
	EndMethod
	
	Method getXJointNode:ISceneNode(jointName:String)
		'  do Not Delete
		Return ISceneNode.createFromHandle(IrrScene_IAnimatedMeshSceneNode_getXJointNode(handle,jointName),False)
	EndMethod

	Method getB3DJointNode:ISceneNode(jointName:String)
		'  do Not Delete
		Return ISceneNode.createFromHandle(IrrScene_IAnimatedMeshSceneNode_getB3DJointNode(handle,jointName),False)
	EndMethod

	Method setAnimationEndCallback(callback:IAnimationEndCallBack=Null)
		If callback=Null Then callback=New IAnimationEndCallback ' default handle to 0
		IrrScene_IAnimatedMeshSceneNode_setAnimationEndCallback(handle,callback.handle)
	EndMethod
	
	Method setAnimationSpeed(framesPerSecond:Float)
		IrrScene_IAnimatedMeshSceneNode_setAnimationSpeed(handle,framesPerSecond)
	EndMethod
	
	Method setCurrentFrame(frame:Int)
		IrrScene_IAnimatedMeshSceneNode_setCurrentFrame(handle,frame)
	EndMethod
	
	Method setFrameLoop:Int(nBegin:Int,nEnd:Int)
		Return IrrScene_IAnimatedMeshSceneNode_setFrameLoop(handle,nBegin,nEnd)
	EndMethod
	
	Method setLoopMode(bPlayAnimationLooped:Int)
		IrrScene_IAnimatedMeshSceneNode_setLoopMode(handle,bPlayAnimationLooped)
	EndMethod
	
	Method setMD2Animation:Int(animationName:String)
		Return IrrScene_IAnimatedMeshSceneNode_setMD2Animation(handle,animationName)
	EndMethod
	
	Method setMD2AnimationFromType:Int(EMD2_ANIMATION_TYPE_anim:Int)
		Return IrrScene_IAnimatedMeshSceneNode_setMD2AnimationFromType(handle,EMD2_ANIMATION_TYPE_anim)
	EndMethod

	Method setReadOnlyMaterials(bReadOnly:Int)
		IrrScene_IAnimatedMeshSceneNode_setReadOnlyMaterials(handle,bReadOnly)
	EndMethod
	
	Method isReadOnlyMaterials:Int()
		Return IrrScene_IAnimatedMeshSceneNode_isReadOnlyMaterials(handle)
	EndMethod
	
	Method setMesh(mesh:IAnimatedMesh)
		IrrScene_IAnimatedMeshSceneNode_setMesh(handle,mesh.handle)
	EndMethod

	Method getMesh:IAnimatedMesh()
		Return IAnimatedMesh.createFromHandle(IrrScene_IAnimatedMeshSceneNode_getMesh(handle),False)
	EndMethod

	Method getStartFrame:Int()
		Return IrrScene_IAnimatedMeshSceneNode_getStartFrame(handle)
	EndMethod
	
	Method getEndFrame:Int()
		Return IrrScene_IAnimatedMeshSceneNode_getEndFrame(handle)
	EndMethod
	
	Method getMD3AbsoluteTransformation:SMD3QuaternionTag(tagname:String)
		Return SMD3QuaternionTag.createFromHandle(IrrScene_IAnimatedMeshSceneNode_getAbsoluteTransformation(handle,tagname),False)
	EndMethod
	
EndType
