' ------------------------------------------------------------------------------------
'  irr::scene::IMesh wrappers
' ------------------------------------------------------------------------------------
Public

Type IMesh Extends Tirr_IUnknown

	Function createFromHandle:IMesh(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IMesh=New IMesh
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method getBoundingBox:AABbox3df()
		Return AABbox3df.createFromHandle(IrrScene_IMesh_getBoundingBox(handle),True)
	EndMethod
	
	Method getMeshBuffer:IMeshBuffer(idx:Int)
		'  do Not Delete this pointer
		Return IMeshBuffer.createFromHandle(IrrScene_IMesh_getMeshBuffer(handle,idx),False)
	EndMethod
	
	Method getMeshBufferCount:Int()
		Return IrrScene_IMesh_getMeshBufferCount(handle)
	EndMethod
	
	Method setMaterialFlag(E_MATERIAL_FLAG_flag:Int,bNewvalue:Int)
		IrrScene_IMesh_setMaterialFlag(handle,E_MATERIAL_FLAG_flag,bNewvalue)
	EndMethod

	Method setBoundingBox(box:AABbox3df)
		IrrScene_IMesh_setBoundingBox(handle,box.handle)
	EndMethod

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrScene_IMesh_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrScene_IMesh_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrScene_IMesh_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod
EndType

