' ------------------------------------------------------------------------------------
'  irr::scene::IMeshBuffer wrappers
' ------------------------------------------------------------------------------------
Public

Type IMeshBuffer Extends Tirr_IUnknown

	Function createFromHandle:IMeshBuffer(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IMeshBuffer=New IMeshBuffer
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method getBoundingBox:AABbox3df()
		Return AABbox3df.createFromHandle(IrrScene_IMeshBuffer_getBoundingBox(handle),True)
	EndMethod
	
	Method getIndexCount:Int()
		Return IrrScene_IMeshBuffer_getIndexCount(handle)
	EndMethod
	
	Method getIndices:Array_u16()
		Return Array_u16.createFromHandle(IrrScene_IMeshBuffer_getIndices(handle))
	EndMethod
	
	Method getMaterial:SMaterial()
		' do not delete
		Return SMaterial.createFromHandle(IrrScene_IMeshBuffer_getMaterial(handle),False)
	EndMethod
	
	Method getVertexCount:Int()
		Return IrrScene_IMeshBuffer_getVertexCount(handle)
	EndMethod
	
	Method getVertexType:Int()
		Return IrrScene_IMeshBuffer_getVertexType(handle)
	EndMethod

	Method getVertices:Array_S3DVertex()
		'  returns a pointer To a S3DVertex array.  do not delete.
		Return Array_S3DVertex.createFromHandle(IrrScene_IMeshBuffer_getVertices(handle),False)
	EndMethod
	Method getVertices2TCoords:Array_S3DVertex2TCoords()
		'  returns a pointer To a S3DVertex2TCoords array.  do not delete.
		Return Array_S3DVertex2TCoords.createFromHandle(IrrScene_IMeshBuffer_getVertices2TCoords(handle),False)
	EndMethod
	Method getVerticesTangents:Array_S3DVertexTangents()
		'  returns a pointer To a S3DVertexTangents array.  do not delete.
		Return Array_S3DVertexTangents.createFromHandle(IrrScene_IMeshBuffer_getVerticesTangents(handle),False)
	EndMethod
	
	Method fillS3DVertexVerticesPtrs(pos:Float Ptr,normals:Float Ptr,tcoords:Float Ptr,colors:Float Ptr,bSwap:Int)
		IrrScene_IMeshBuffer_fillS3DVertexVerticesPtrs(handle,pos,normals,tcoords,colors,bSwap)
	EndMethod	
	Method fillS3DVertex2TCoordsVerticesPtrs(pos:Float Ptr,normals:Float Ptr,tcoords:Float Ptr,colors:Float Ptr,tcoords2:Float Ptr,bSwap:Int)
		IrrScene_IMeshBuffer_fillS3DVertex2TCoordsVerticesPtrs(handle,pos,normals,tcoords,colors,tcoords2,bSwap)
	EndMethod	
	Method fillS3DVertexTangentsVerticesPtrs(pos:Float Ptr,normals:Float Ptr,tcoords:Float Ptr,colors:Float Ptr,tangents:Float Ptr,binormals:Float Ptr,bSwap:Int)	
		IrrScene_IMeshBuffer_fillS3DVertexTangentsVerticesPtrs(handle,pos,normals,tcoords,colors,tangents,binormals,bSwap)
	EndMethod
	
	Method fillIndicesPtr(indicies:Short Ptr,bSwap:Int)
		IrrScene_IMeshBuffer_fillIndicesPtr(handle,indicies,bSwap)
	EndMethod

	Method getVertex:S3DVertex(idx:Int)
		' do not delete
		Return S3DVertex.createFromHandle(IrrScene_IMeshBuffer_getVertex(handle,idx),False)
	EndMethod
	Method getVertex2TCoords:S3DVertex2TCoords(idx:Int)
		' do not delete
		Return S3DVertex2TCoords.createFromHandle(IrrScene_IMeshBuffer_getVertex2TCoords(handle,idx),False)
	EndMethod
	Method getVertexTangents:S3DVertexTangents(idx:Int)
		' do not delete
		Return S3DVertexTangents.createFromHandle(IrrScene_IMeshBuffer_getVertexTangents(handle,idx),False)
	EndMethod

	Method getVertexPitch:Int()
		Return IrrScene_IMeshBuffer_getVertexPitch(handle)
	EndMethod
	
	Method setBoundingBox(box:AABbox3df)
		IrrScene_IMeshBuffer_setBoundingBox(handle,box.handle)
	EndMethod
	
	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrScene_IMeshBuffer_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrScene_IMeshBuffer_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrScene_IMeshBuffer_grab(handle)
	EndMethod
	
	Method Delete()
		If (mustdelete) Then drop()
	EndMethod
EndType


