
extern "C" 
{

//------------------------------------------------------------------------------------
// irr::scene::IMeshBuffer wrappers
//------------------------------------------------------------------------------------

	void IrrScene_IMeshBuffer_fillS3DVertexVerticesPtrs(IMeshBuffer* mb,f32* pos,f32* normals,f32* tcoords,f32* colors,bool bSwap)
	{
		if (mb) {			
			if (mb->getVertexType()==EVT_STANDARD) {
				s32 vertCnt=mb->getVertexCount();
				for (int i=0; i<vertCnt; i++) {
					pos[(i*3)]=((S3DVertex*)mb->getVertices())[i].Pos.X;
					pos[(i*3)+1]=((S3DVertex*)mb->getVertices())[i].Pos.Y;
					if (bSwap) {
						pos[(i*3)+2]=-((S3DVertex*)mb->getVertices())[i].Pos.Z;
					} else {
						pos[(i*3)+2]=((S3DVertex*)mb->getVertices())[i].Pos.Z;
					}
									
					normals[(i*3)]=((S3DVertex*)mb->getVertices())[i].Normal.X;
					normals[(i*3)+1]=((S3DVertex*)mb->getVertices())[i].Normal.Y;
					normals[(i*3)+2]=((S3DVertex*)mb->getVertices())[i].Normal.Z;
				
					tcoords[(i*2)]=((S3DVertex*)mb->getVertices())[i].TCoords.X;
					tcoords[(i*2)+1]=((S3DVertex*)mb->getVertices())[i].TCoords.Y;
				
					colors[(i*4)]=SColorf(((S3DVertex*)mb->getVertices())[i].Color).r;
					colors[(i*4)+1]=SColorf(((S3DVertex*)mb->getVertices())[i].Color).g;
					colors[(i*4)+2]=SColorf(((S3DVertex*)mb->getVertices())[i].Color).b;
					colors[(i*4)+3]=SColorf(((S3DVertex*)mb->getVertices())[i].Color).a;
				}	
			}
		}
	}

	void IrrScene_IMeshBuffer_fillS3DVertex2TCoordsVerticesPtrs(IMeshBuffer* mb,f32* pos,f32* normals,f32* tcoords,f32* colors,f32* tcoords2,bool bSwap)
	{
		if (mb) {			
			if (mb->getVertexType()==EVT_2TCOORDS) {
				s32 vertCnt=mb->getVertexCount();
				for (int i=0; i<vertCnt; i++) {
					pos[(i*3)]=((S3DVertex2TCoords*)mb->getVertices())[i].Pos.X;
					pos[(i*3)+1]=((S3DVertex2TCoords*)mb->getVertices())[i].Pos.Y;
					if (bSwap) {
						pos[(i*3)+2]=-((S3DVertex2TCoords*)mb->getVertices())[i].Pos.Z;
					} else {
						pos[(i*3)+2]=((S3DVertex2TCoords*)mb->getVertices())[i].Pos.Z;
					}
									
					normals[(i*3)]=((S3DVertex2TCoords*)mb->getVertices())[i].Normal.X;
					normals[(i*3)+1]=((S3DVertex2TCoords*)mb->getVertices())[i].Normal.Y;
					normals[(i*3)+2]=((S3DVertex2TCoords*)mb->getVertices())[i].Normal.Z;
				
					tcoords[(i*2)]=((S3DVertex2TCoords*)mb->getVertices())[i].TCoords.X;
					tcoords[(i*2)+1]=((S3DVertex2TCoords*)mb->getVertices())[i].TCoords.Y;
	
					tcoords2[(i*2)]=((S3DVertex2TCoords*)mb->getVertices())[i].TCoords2.X;
					tcoords2[(i*2)+1]=((S3DVertex2TCoords*)mb->getVertices())[i].TCoords2.Y;
				
					colors[(i*4)]=SColorf(((S3DVertex2TCoords*)mb->getVertices())[i].Color).r;
					colors[(i*4)+1]=SColorf(((S3DVertex2TCoords*)mb->getVertices())[i].Color).g;
					colors[(i*4)+2]=SColorf(((S3DVertex2TCoords*)mb->getVertices())[i].Color).b;
					colors[(i*4)+3]=SColorf(((S3DVertex2TCoords*)mb->getVertices())[i].Color).a;
				}	
			}
		}
	}

	void IrrScene_IMeshBuffer_fillS3DVertexTangentsVerticesPtrs(IMeshBuffer* mb,f32* pos,f32* normals,f32* tcoords,f32* colors,f32* tangents,f32* binormals,bool bSwap)
	{
		if (mb) {			
			if (mb->getVertexType()==EVT_TANGENTS) {
				s32 vertCnt=mb->getVertexCount();
				for (int i=0; i<vertCnt; i++) {
					pos[(i*3)]=((S3DVertexTangents*)mb->getVertices())[i].Pos.X;
					pos[(i*3)+1]=((S3DVertexTangents*)mb->getVertices())[i].Pos.Y;
					if (bSwap) {
						pos[(i*3)+2]=-((S3DVertexTangents*)mb->getVertices())[i].Pos.Z;
					} else {
						pos[(i*3)+2]=((S3DVertexTangents*)mb->getVertices())[i].Pos.Z;
					}
									
					normals[(i*3)]=((S3DVertexTangents*)mb->getVertices())[i].Normal.X;
					normals[(i*3)+1]=((S3DVertexTangents*)mb->getVertices())[i].Normal.Y;
					normals[(i*3)+2]=((S3DVertexTangents*)mb->getVertices())[i].Normal.Z;
				
					tcoords[(i*2)]=((S3DVertexTangents*)mb->getVertices())[i].TCoords.X;
					tcoords[(i*2)+1]=((S3DVertexTangents*)mb->getVertices())[i].TCoords.Y;

					tangents[(i*3)]=((S3DVertexTangents*)mb->getVertices())[i].Tangent.X;
					tangents[(i*3)+1]=((S3DVertexTangents*)mb->getVertices())[i].Tangent.Y;
					tangents[(i*3)+2]=((S3DVertexTangents*)mb->getVertices())[i].Tangent.Z;
					
					binormals[(i*3)]=((S3DVertexTangents*)mb->getVertices())[i].Binormal.X;
					binormals[(i*3)+1]=((S3DVertexTangents*)mb->getVertices())[i].Binormal.Y;
					binormals[(i*3)+2]=((S3DVertexTangents*)mb->getVertices())[i].Binormal.Z;

					colors[(i*4)]=SColorf(((S3DVertexTangents*)mb->getVertices())[i].Color).r;
					colors[(i*4)+1]=SColorf(((S3DVertexTangents*)mb->getVertices())[i].Color).g;
					colors[(i*4)+2]=SColorf(((S3DVertexTangents*)mb->getVertices())[i].Color).b;
					colors[(i*4)+3]=SColorf(((S3DVertexTangents*)mb->getVertices())[i].Color).a;
				}	
			}
		}
	}

	void IrrScene_IMeshBuffer_fillIndicesPtr(IMeshBuffer* mb,u16* indicies,bool bSwap)
	{
		if (mb) {
			s32 idxCnt=mb->getIndexCount();
			for (int i=0; i<(idxCnt/3); i++) {
				
				if (bSwap) {
					indicies[(i*3)+2]=mb->getIndices()[i*3];
					indicies[(i*3)+1]=mb->getIndices()[(i*3)+1];
					indicies[i*3]=mb->getIndices()[(i*3)+2];
				} else {
					indicies[i*3]=mb->getIndices()[i*3];
					indicies[(i*3)+1]=mb->getIndices()[(i*3)+1];
					indicies[(i*3)+2]=mb->getIndices()[(i*3)+2];
				}

			}
		}
	}

	// do not delete
	aabbox3d<f32>* IrrScene_IMeshBuffer_getBoundingBox(IMeshBuffer* mb)
	{
		if (mb)
			return new aabbox3d<f32>(mb->getBoundingBox());
		else return 0;
	}
	
	u32 IrrScene_IMeshBuffer_getIndexCount(IMeshBuffer* mb)
	{
		if (mb)
			return mb->getIndexCount();
		else return 0;
	}
	
	// do not delete internal pointers
	array<u16>* IrrScene_IMeshBuffer_getIndices(IMeshBuffer* mb)
	{
		if (mb) {
			array<u16>* retval=new array<u16>();
			retval->set_free_when_destroyed(false);
			retval->set_pointer(mb->getIndices(),mb->getIndexCount());
			return retval;
		} else return 0;
	}
	
	// do not delete
	SMaterial* IrrScene_IMeshBuffer_getMaterial(IMeshBuffer* mb)
	{
		if (mb)
			return &mb->getMaterial();
		else return 0;
	}
	
	u32 IrrScene_IMeshBuffer_getVertexCount(IMeshBuffer* mb)
	{
		if (mb)
			return mb->getVertexCount();
		else return 0;
	}
	
	// returns a pointer to a S3DVertex array
	array<S3DVertex>* IrrScene_IMeshBuffer_getVertices(IMeshBuffer* mb)
	{
		if (mb) {
			if (mb->getVertexType()==EVT_STANDARD) {
				array<S3DVertex>* retval=new array<S3DVertex>();
				retval->set_free_when_destroyed(false);
				retval->set_pointer((S3DVertex*)mb->getVertices(),mb->getVertexCount());
				return retval;
			} else return 0;
		} else return 0;
	}
	
	// returns a pointer to a S3DVertex2TCoords array
	array<S3DVertex2TCoords>* IrrScene_IMeshBuffer_getVertices2TCoords(IMeshBuffer* mb)
	{
		if (mb) {
			if (mb->getVertexType()==EVT_2TCOORDS) {
				array<S3DVertex2TCoords>* retval=new array<S3DVertex2TCoords>();
				retval->set_free_when_destroyed(false);
				retval->set_pointer((S3DVertex2TCoords*)mb->getVertices(),mb->getVertexCount());
				return retval;
			} else return 0;
		} else return 0;
	}
	
	// returns a pointer to a S3DVertexTangents array
	array<S3DVertexTangents>* IrrScene_IMeshBuffer_getVerticesTangents(IMeshBuffer* mb)
	{
		if (mb) {
			if (mb->getVertexType()==EVT_TANGENTS) {
				array<S3DVertexTangents>* retval=new array<S3DVertexTangents>();
				retval->set_free_when_destroyed(false);
				retval->set_pointer((S3DVertexTangents*)mb->getVertices(),mb->getVertexCount());
				return retval;
			} else return 0;
		} else return 0;
	}
	
	s32 IrrScene_IMeshBuffer_getVertexType(IMeshBuffer* mb)
	{
		if (mb)
			return mb->getVertexType();
		else return -1;
	}
	
	// do not delete
	S3DVertex* IrrScene_IMeshBuffer_getVertex(IMeshBuffer* mb,s32 idx)
	{
		if (mb)
			if (mb->getVertexType()==EVT_STANDARD)
				return &((S3DVertex*)mb->getVertices())[idx];
			else return 0;
		else return 0;
	}
	
	// do not delete
	S3DVertex2TCoords* IrrScene_IMeshBuffer_getVertex2TCoords(IMeshBuffer* mb,s32 idx)
	{
		if (mb)
			if (mb->getVertexType()==EVT_2TCOORDS)
				return &((S3DVertex2TCoords*)mb->getVertices())[idx];
			else return 0;
		else return 0;
	}
	
	// do not delete
	S3DVertexTangents* IrrScene_IMeshBuffer_getVertexTangents(IMeshBuffer* mb,s32 idx)
	{
		if (mb)
			if (mb->getVertexType()==EVT_TANGENTS)
				return &((S3DVertexTangents*)mb->getVertices())[idx];
			else return 0;
		else return 0;
	}

	u32 IrrScene_IMeshBuffer_getVertexPitch(IMeshBuffer* mb)
	{
		if (mb)
			return mb->getVertexPitch();
		else return -1;
	}
	
	void IrrScene_IMeshBuffer_setBoundingBox(IMeshBuffer* mb,const core::aabbox3df& box)
	{
		if (mb)
			mb->setBoundingBox(box);
	}


	bool IrrScene_IMeshBuffer_drop(IMeshBuffer* unk)
	{
		if (unk)
			return unk->drop();
		else return 0;
	}
	
	const c8* IrrScene_IMeshBuffer_getDebugName(IMeshBuffer* unk)
	{
		if (unk)
			return unk->getDebugName();
		else return "";
	}
	
	void IrrScene_IMeshBuffer_grab(IMeshBuffer* unk)
	{
		if (unk)
			unk->grab();
	}
	
}
