' ------------------------------------------------------------------------------------
'  irr::scene::IMeshCache wrappers
' ------------------------------------------------------------------------------------
Public

Type IMeshCache Extends Tirr_IUnknown

	Function createFromHandle:IMeshCache(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IMeshCache=New IMeshCache
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method addMesh(filename:String, mesh:IAnimatedMesh)
		IrrScene_IMeshCache_addMesh(handle,filename,mesh.handle)
	EndMethod
	
	Method removeMesh(mesh:IAnimatedMesh)
		IrrScene_IMeshCache_removeMesh(handle,mesh.handle)
	EndMethod
	
	Method getMeshCount:Int()
		Return IrrScene_IMeshCache_getMeshCount(handle)
	EndMethod
	
	Method getMeshIndex:Int(mesh:IAnimatedMesh)
		Return IrrScene_IMeshCache_getMeshIndex:Int(handle,mesh.handle)
	EndMethod
	
	' do not delete
	Method getMeshByIndex:IAnimatedMesh(index:Int)
		Return IAnimatedMesh.createFromHandle(IrrScene_IMeshCache_getMeshByIndex(handle,index),False)
	EndMethod

	Method getMeshFilenameByIdx:String(index:Int)
		Return String.FromCString(IrrScene_IMeshCache_getMeshFilenameByIdx(handle,index))
	EndMethod
	
	Method getAnimatedMeshFilename:String(mesh:IAnimatedMesh)
		Return String.FromCString(IrrScene_IMeshCache_getAnimatedMeshFilename(handle,mesh.handle))
	EndMethod
	
	Method getMeshFilename:String(mesh:IMesh)
		Return String.FromCString(IrrScene_IMeshCache_getMeshFilename(handle,mesh.handle))
	EndMethod

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrScene_IMeshCache_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrScene_IMeshCache_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrScene_IMeshCache_grab(handle)
	EndMethod
	
	Method Delete()
		If (mustdelete) Then drop()
	EndMethod	
EndType


