//------------------------------------------------------------------------------------
// irr::scene::IMeshCache wrappers
//------------------------------------------------------------------------------------

extern "C"
{

	void IrrScene_IMeshCache_addMesh(IMeshCache* imc,const c8* filename, IAnimatedMesh* mesh)
	{
		if (imc)
			imc->addMesh(filename,mesh);
	}

	void IrrScene_IMeshCache_removeMesh(IMeshCache* imc,IAnimatedMesh* mesh)
	{
		if (imc)
			imc->removeMesh(mesh);
	}

	s32 IrrScene_IMeshCache_getMeshCount(IMeshCache* imc)
	{
		if (imc)
			return imc->getMeshCount();
		else return 0;
	}

	s32 IrrScene_IMeshCache_getMeshIndex(IMeshCache* imc,IAnimatedMesh* mesh)
	{
		if (imc)
			return imc->getMeshIndex(mesh);
		else return 0;
	}

	IAnimatedMesh* IrrScene_IMeshCache_getMeshByIndex(IMeshCache* imc,s32 index)
	{
		if (imc)
			return imc->getMeshByIndex(index);
		else return 0;
	}

	const c8* IrrScene_IMeshCache_getMeshFilenameByIdx(IMeshCache* imc,s32 index)
	{
		if (imc)
			return imc->getMeshFilename(index);
		else return 0;
	}

	const c8* IrrScene_IMeshCache_getAnimatedMeshFilename(IMeshCache* imc,IAnimatedMesh* mesh)
	{
		if (imc)
			return imc->getMeshFilename(mesh);
		else return 0;
	}

	const c8* IrrScene_IMeshCache_getMeshFilename(IMeshCache* imc,IMesh* mesh)
	{
		if (imc)
			return imc->getMeshFilename(mesh);
		else return 0;
	}
	
	bool IrrScene_IMeshCache_drop(IMeshCache* unk)
	{
		if (unk)
			return unk->drop();
		else return 0;
	}
	
	const c8* IrrScene_IMeshCache_getDebugName(IMeshCache* unk)
	{
		if (unk)
			return unk->getDebugName();
		else return "";
	}
	
	void IrrScene_IMeshCache_grab(IMeshCache* unk)
	{
		if (unk)
			unk->grab();
	}
	
}

