' TODO: need to make bound version

Type ISceneNodeAnimatorFactory Extends Tirr_IUnknown

	Rem
	//! creates a scene node animator based on its Type id
	/** \param Type: Type of the scene node animator To add.
	\param target: Target scene node of the New animator.
	\Return Returns pointer To the New scene node animator Or Null If Not successful. You need To
	drop this pointer after calling this, see IUnknown::drop() For details. */
	EndRem
	Method createSceneNodeAnimatorFromType:ISceneNodeAnimator(ESCENE_NODE_ANIMATOR_TYPE:Int,target:ISceneNode)
		Return ISceneNodeAnimator.createFromHandle(IrrScene_ISceneNodeAnimatorFactory_createSceneNodeAnimatorFromType(handle,ESCENE_NODE_ANIMATOR_TYPE,target.handle),True)
	EndMethod
	
	Rem
	//! creates a scene node animator based on its Type name
	/** \param typeName: Type of the scene node animator To add.
	\param target: Target scene node of the New animator.
	\Return Returns pointer To the New scene node animator Or Null If Not successful. You need To
	drop this pointer after calling this, see IUnknown::drop() For details. */
	EndRem
	Method createSceneNodeAnimator:ISceneNodeAnimator(typeName:String,target:ISceneNode)
		Return ISceneNodeAnimator.createFromHandle(IrrScene_ISceneNodeAnimatorFactory_createSceneNodeAnimatorFromName(handle,typeName,target.handle),True)
	EndMethod

	Rem
	//! returns amount of scene node animator types this factory is able To create
	EndRem
	Method getCreatableSceneNodeAnimatorTypeCount:Int()
		Return IrrScene_ISceneNodeAnimatorFactory_getCreatableSceneNodeAnimatorTypeCount(handle)
	EndMethod

	Rem
	//! returns Type of a createable scene node animator Type
	/** \param idx: Index of scene node animator Type in this factory. Must be a value between 0 And
	getCreatableSceneNodeTypeCount() */
	EndRem
	Method getCreateableSceneNodeAnimatorType:Int(idx:Int) ' returns ESCENE_NODE_ANIMATOR_TYPE
		Return IrrScene_ISceneNodeAnimatorFactory_getCreateableSceneNodeAnimatorType(handle,idx)
	EndMethod

	Rem
	//! returns Type name of a createable scene node animator Type 
	/** \param idx: Index of scene node animator Type in this factory. Must be a value between 0 And
	getCreatableSceneNodeAnimatorTypeCount() */
	EndRem
	Method getCreateableSceneNodeAnimatorTypeNameFromIndex:String(idx:Int)
		Return IrrScene_ISceneNodeAnimatorFactory_getCreateableSceneNodeAnimatorTypeNameFromIndex(handle,idx)
	EndMethod

	Rem
	//! returns Type name of a createable scene node animator Type 
	/** \param Type: Type of scene node animator. 
	\Return: Returns name of scene node animator Type If this factory can create the Type, otherwise 0. */
	EndRem
	Method getCreateableSceneNodeAnimatorTypeNameFromType:String(ESCENE_NODE_ANIMATOR_TYPE:Int)
		Return IrrScene_ISceneNodeAnimatorFactory_getCreateableSceneNodeAnimatorTypeNameFromType(handle,ESCENE_NODE_ANIMATOR_TYPE)
	EndMethod

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrScene_ISceneNodeAnimatorFactory_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrScene_ISceneNodeAnimatorFactory_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrScene_ISceneNodeAnimatorFactory_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod
	' --------------------------------------------------------------------------------
	' creation routines
	' --------------------------------------------------------------------------------

	' this should only be called on an extended type
	Function create:ISceneNodeAnimatorFactory(pGenFunc:Byte Ptr) Final
		'Return createFromHandle(IrrScene_BMXISceneNodeAnimatorFactory_new(),True,pGenFunc)
		Return Null
	EndFunction

	Function createFromHandle:ISceneNodeAnimatorFactory(pHandle:Int,bMustDel:Int,pGenFunc:Byte Ptr=Null)
		If Not pHandle Then Return Null
		Local oRetVal:ISceneNodeAnimatorFactory=Null
		
		If pGenFunc
			' use the funtion pointer to generate
			Local generate:ISceneNodeAnimatorFactory()=pGenFunc
		
			oRetVal=generate()
		Else
			oRetVal=New ISceneNodeAnimatorFactory
		EndIf

		' turn binding on if this is the first and there was a gen func passed in
		oRetVal.bIsBound=bMustDel And pGenFunc
		
		oRetVal.attach(pHandle,bMustDel)
		
		Return oRetVal
	EndFunction
	
	' --------------------------------------------------------------------------------
	' bindings
	' --------------------------------------------------------------------------------	

	Method bind(rec:Int) Final
		Super.bind(rec)
	EndMethod
	
EndType



