' ------------------------------------------------------------------------------------
'  irr::scene::SMeshBufferLightMap wrappers (parent is IMeshBuffer)
' ------------------------------------------------------------------------------------
Public

Type SMeshBufferLightMap Extends IMeshBuffer Final

	Function create:SMeshBufferLightMap()
		Return createFromHandle(IrrScene_SMeshBufferLightMap_new(),True)
	EndFunction

	Function createFromHandle:SMeshBufferLightMap(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SMeshBufferLightMap=New SMeshBufferLightMap
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method getBoundingBox:AABbox3df()
		Return AABbox3df.createFromHandle(IrrScene_SMeshBufferLightMap_getBoundingBox(handle),True)
	EndMethod
	
	Method getIndexCount:Int()
		Return IrrScene_SMeshBufferLightMap_getIndexCount(handle)
	EndMethod
	
	Method getIndices:Array_u16()
		'  do Not Delete this pointer
		Return Array_u16.createFromHandle(IrrScene_SMeshBufferLightMap_getIndices(handle),False)
	EndMethod
	
	Method getMaterial:SMaterial()
		'  do Not Delete this pointer
		Return SMaterial.createFromHandle(IrrScene_SMeshBufferLightMap_getMaterial(handle),False)
	EndMethod
	
	Method getVertexCount:Int()
		Return IrrScene_SMeshBufferLightMap_getVertexCount(handle)
	EndMethod
	
	Method getVertexType:Int()
		Return IrrScene_SMeshBufferLightMap_getVertexType(handle)
	EndMethod
	
	' TODO: cant have different return types on an overriden method
	Method getVertices_SMBLM:Array_S3DVertex2TCoords()
		'  returns a pointer To array of S3DVertex2TCoords.  do Not Delete this pointer.
		Return Array_S3DVertex2TCoords.createFromHandle(IrrScene_SMeshBufferLightMap_getVertices(handle),False)
	EndMethod

	Method recalculateBoundingBox()
		IrrScene_SMeshBufferLightMap_recalculateBoundingBox(handle)
	EndMethod

	Method setBoundingBox(box:AABbox3df)
		IrrScene_SMeshBufferLightMap_setBoundingBox(handle,box.handle)
	EndMethod
	
	Method getVertexPitch:Int()
		IrrScene_SMeshBufferLightMap_getVertexPitch(handle)
	EndMethod

EndType

