//------------------------------------------------------------------------------------
// irr::scene::SMeshBufferLightMap wrappers (parent is IMeshBuffer)
//------------------------------------------------------------------------------------

extern "C" 
{

	SMeshBufferLightMap* IrrScene_SMeshBufferLightMap_new()
	{
		return new SMeshBufferLightMap();
	}
	
	// do not delete this pointer
	aabbox3d<f32>* IrrScene_SMeshBufferLightMap_getBoundingBox(SMeshBufferLightMap* mb)
	{
		if (mb)
			return new aabbox3d<f32>(mb->getBoundingBox());
		else return 0;
	}
	
	u32 IrrScene_SMeshBufferLightMap_getIndexCount(SMeshBufferLightMap* mb)
	{
		if (mb)
			return mb->getIndexCount();
		else return 0;
	}
	
	// do not delete this pointer
	array<u16>* IrrScene_SMeshBufferLightMap_getIndices(SMeshBufferLightMap* mb)
	{
		if (mb) 
			return &mb->Indices;
		else return 0;
	}
	
	// do not delete this pointer
	SMaterial* IrrScene_SMeshBufferLightMap_getMaterial(SMeshBufferLightMap* mb)
	{
		if (mb)
			return &mb->getMaterial();
		else return 0;
	}
	
	u32 IrrScene_SMeshBufferLightMap_getVertexCount(SMeshBufferLightMap* mb)
	{
		if (mb)
			return mb->getVertexCount();
		else return 0;
	}
	
	s32 IrrScene_SMeshBufferLightMap_getVertexType(SMeshBufferLightMap* mb)
	{
		if (mb)
			return mb->getVertexType();
		else return -1;
	}
	
	// returns a pointer To array of S3DVertex2TCoords.  do Not Delete this pointer.
	array<S3DVertex2TCoords>* IrrScene_SMeshBufferLightMap_getVertices(SMeshBufferLightMap* mb)
	{
		if (mb) 
			return &mb->Vertices;
		else return 0;
	}
	
	void IrrScene_SMeshBufferLightMap_recalculateBoundingBox(SMeshBufferLightMap* mb)
	{
		if (mb)
			mb->recalculateBoundingBox();
	}

	void IrrScene_SMeshBufferLightMap_setBoundingBox(SMeshBufferLightMap* mb,const core::aabbox3df& box)
	{
		if (mb)
			mb->setBoundingBox(box);
	}
	
	u32 IrrScene_SMeshBufferLightMap_getVertexPitch(SMeshBufferLightMap* mb)
	{
		if (mb)
			return mb->getVertexPitch();
		else return -1;
	}
}