' ------------------------------------------------------------------------------------
'  irr::scene::SViewFrustum wrappers
' ------------------------------------------------------------------------------------
Public

Type SViewFrustum Extends IrrBase Final

	Function createFromHandle:SViewFrustum(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:SViewFrustum=New SViewFrustum
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Function create:SViewFrustum()
		Return createFromHandle(IrrScene_SViewFrustum_new())
	EndFunction
	
	Function createFromMatrix:SViewFrustum(matrix:Matrix4)
		Return createFromHandle(IrrScene_SViewFrustum_newFromMatrix(matrix.handle))
	EndFunction
	
	Method Delete()
		If (mustdelete) Then IrrScene_SViewFrustum_del(handle)
	EndMethod	
	
	Method getBoundingBox:AABbox3df()
		Return AABbox3df.createFromHandle(IrrScene_SViewFrustum_getBoundingBox(handle))
	EndMethod
	
	Method getFarLeftDown:Vector3df()
		Return Vector3df.createFromHandle(IrrScene_SViewFrustum_getFarLeftDown(handle))
	EndMethod
	
	Method getFarLeftUp:Vector3df()
		Return Vector3df.createFromHandle(IrrScene_SViewFrustum_getFarLeftUp(handle))
	EndMethod

	Method getFarRightDown:Vector3df()
		Return Vector3df.createFromHandle(IrrScene_SViewFrustum_getFarRightDown(handle))
	EndMethod
	
	Method getFarRightUp:Vector3df()
		Return Vector3df.createFromHandle(IrrScene_SViewFrustum_getFarRightUp(handle))
	EndMethod

	Method recalculateBoundingBox()
		IrrScene_SViewFrustum_recalculateBoundingBox(handle)
	EndMethod
	
	Method transform(matrix:Matrix4)
		IrrScene_SViewFrustum_transform(handle,matrix.handle)
	EndMethod
	
	Method boundingBox:AABbox3df()
		'  do Not Delete
		Return AABbox3df.createFromHandle(IrrScene_SViewFrustum_boundingBox(handle),False)
	EndMethod
	
	Method cameraPosition:Vector3df()
		'  do Not Delete
		Return Vector3df.createFromHandle(IrrScene_SViewFrustum_cameraPosition(handle),False)
	EndMethod
	
	Method getPlane:Plane3df(idx:Int)
		'  do Not Delete
		Return Plane3df.createFromHandle(IrrScene_SViewFrustum_getPlane(handle,idx),False)
	EndMethod
	
	Method setPlane(plane:Plane3df,idx:Int)
		'  safe To Delete plane passed in
		IrrScene_SViewFrustum_setPlane(handle,plane.handle,idx)
	EndMethod

	Method setFrom(mat:Matrix4)
		IrrScene_SViewFrustum_setFrom(handle,mat.handle)
	EndMethod
	
	Method setTransformState(E_TRANSFORMATION_STATE:Int)
		IrrScene_SViewFrustum_setTransformState(handle,E_TRANSFORMATION_STATE)
	EndMethod

EndType





