//------------------------------------------------------------------------------------
// irr::video::SLight wrappers
//
// WARNING: do NOT release handles obtained via the get() methods
//------------------------------------------------------------------------------------

extern "C" SLight* IrrVideo_SLight_new()
{
	return new SLight();
}

extern "C" void IrrVideo_SLight_del(SLight* del)
{
	if (del)
		delete del;
		
	del=0;
}

extern "C" SColorf* IrrVideo_SLight_getAmbientColor(SLight* light)
{
	if (light)
		return &light->AmbientColor;
	else
		return 0;
}

extern "C" SColorf* IrrVideo_SLight_getDiffuseColor(SLight* light)
{
	if (light)
		return &light->DiffuseColor;
	else
		return 0;
}

extern "C" SColorf* IrrVideo_SLight_getSpecularColor(SLight* light)
{
	if (light)
		return &light->SpecularColor;
	else
		return 0;
}

extern "C" vector3df* IrrVideo_SLight_getPosition(SLight* light)
{
	if (light)
		return &light->Position;
	else
		return 0;
}

extern "C" bool IrrVideo_SLight_getCastShadows(SLight* light)
{
	if (light)
		return light->CastShadows;
	else
		return false;
}

extern "C" void IrrVideo_SLight_setCastShadows(SLight* light,bool bCastShadows)
{
	if (light)
		light->CastShadows=bCastShadows;
}

extern "C" f32 IrrVideo_SLight_getRadius(SLight* light)
{
	if (light)
		return light->Radius;
	else
		return 0.0f;
}

extern "C" void IrrVideo_SLight_setRadius(SLight* light,f32 newrad)
{
	if (light)
		light->Radius=newrad;
}

extern "C" s32 IrrVideo_SLight_getType(SLight* light)
{
	if (light)
		return light->Type;
	else	return -1;
}

extern "C" void IrrVideo_SLight_setType(SLight* light,E_LIGHT_TYPE newType)
{
	if (light)
		light->Type=newType;
}
